Unit qst2e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS12_p;

procedure qst2e(var RINT :Array of Extended; A :Extended;
                B :Extended; F :Proc_F3E_A; N :Integer; EPS :Extended;
                K :Integer; var IND :Array of Integer;
                var R :Array of Extended; var IERR :Integer);

implementation

procedure qst2e(var RINT :Array of Extended; A :Extended;
                B :Extended; F :Proc_F3E_A; N :Integer; EPS :Extended;
                K :Integer; var IND :Array of Integer;
                var R :Array of Extended; var IERR :Integer);
var
I,J,K1,K2 :Integer;
E,H,RH,RI :Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100;
begin
IERR := 0;
for I:=1 to N do
 begin
  R[(I-1)+1*N] := 0.e0;
  IND[I-1] := 0;
_10:
 end;
K1 := K;
if ( K  <=  0 ) 
 then K1 := 1;
F(A,RINT,IND);
F(B,R,IND);
H := (B - A)/K1;
for I:=1 to N do
 begin
  RINT[I-1] := (RINT[I-1] + R[(I-1)+0*N])*H*0.5e0;
_20:
 end;
if ( K1  =  1 ) 
 then goto _50;
K2 := K1 - 1;
for J:=1 to K2 do
 begin
  F(A + J*H,R,IND);
  for I:=1 to N do
   begin
    RINT[I-1] := RINT[I-1] + R[(I-1)+0*N]*H;
_30:
   end;
_40:
 end;
_50:
if ( EPS  <=  0.e0 ) 
 then goto _100;
_60:
H := H*0.5e0;
for J:=1 to K1 do
 begin
  F(A + (2.e0*J - 1.e0)*H,R,IND);
  for I:=1 to N do
   begin
    R[(I-1)+1*N] := R[(I-1)+1*N] + R[(I-1)+0*N];
_70:
   end;
_80:
 end;
K2 := 1;
for I:=1 to N do
 begin
  if ( IND[I-1]  >  0 ) 
   then goto _90;
  RH := R[(I-1)+1*N]*H;
  RI := RINT[I-1]*0.5e0;
  RINT[I-1] := RH + RI;
  E := Abs(RH-RI)/(1.e0 + Abs(RINT[I-1]));
  if ( E  <=  EPS ) 
   then IND[I-1] := K1;
  if ( IND[I-1]  =  0 ) 
   then K2 := 0;
  R[(I-1)+1*N] := 0.e0;
_90:
 end;
if ( K2  >  0 ) 
 then goto _100;
K1 := K1 + K1;
if ( K1  <=  1048576 ) 
 then goto _60;
IERR := 65;
UTQS12(IERR,8);
_100:
end;

end.
